package com.fdc.screen.servlet;

import com.sun.grizzly.comet.CometContext;
import com.sun.grizzly.comet.CometEngine;
import com.sun.grizzly.cometd.BayeuxParser;
import com.sun.grizzly.cometd.CometdRequest;
import com.sun.grizzly.cometd.CometdResponse;
import com.sun.grizzly.cometd.EventRouter;
import com.sun.grizzly.cometd.EventRouterImpl;
import com.sun.grizzly.cometd.bayeux.Data;
import com.sun.grizzly.cometd.bayeux.DeliverResponse;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class SendDataServlet extends HttpServlet {

    private final BayeuxParser bayeuxParser;
    private final EventRouter eventRouter;
//    public ScheduledThreadPoolExecutor timer = new ScheduledThreadPoolExecutor(1);

    public SendDataServlet() {
        bayeuxParser = new BayeuxParser();
        eventRouter = new EventRouterImpl(bayeuxParser);
    }

    /**
     * Initialize the Servlet by creating the CometContext.
     */
    @Override
    public void init(ServletConfig config) throws ServletException {
        super.init(config);

//        timer.scheduleAtFixedRate(new Runnable(){
//            public void run(){
//                //Map channels = (Map)getServletContext().getAttribute("channellist");
//                CometEngine engine = CometEngine.getEngine();
//                String allChannels = "/chat/*";
//                CometContext context = engine.getCometContext(allChannels);
//                System.out.println("context:"+context);
//
//                if (context != null) {
//                    Map<String, Object> map = new HashMap<String, Object>();
//                    map.put("chat", "Wake up call from the chatroom :-)");
//                    map.put("user", "ChatPigner");
//                    Data data = new Data();
//                    data.setMapData(map);
//                    data.setChannel(allChannels);
//
//                    DeliverResponse deliverResponse = new DeliverResponse();
//                    deliverResponse.setChannel(allChannels);
//                    deliverResponse.setClientId("");
//                    deliverResponse.setData(data);
//                    deliverResponse.setLast(true);
//                    deliverResponse.setFollow(true);
//                    try{
//                        context.notify(deliverResponse);
//                    } catch (IOException ex) {};
//
//                }
//            }
//        }, 10, 10, TimeUnit.SECONDS);
}


    protected void sendMesssage(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        Map channelMap = (Map)getServletContext().getAttribute("channellist");
        //ServletOutputStream out = res.getOutputStream();
        CometEngine engine = CometEngine.getEngine();
        String agentName=req.getParameter("agentName");
        System.out.println("sendMessage:agentName:"+agentName);

        if (agentName != null){
            CometContext context = engine.getCometContext("/chat/"+agentName);
            if (context != null && agentName != null){
                System.out.println("sendMessage:create map, data object");
                Map<String, Object> map = new HashMap<String, Object>();
                map.put("agentID", req.getParameter("agentID"));
                map.put("callType", req.getParameter("callType"));
                map.put("callerID", req.getParameter("callerID"));
                map.put("mid", req.getParameter("mid"));
                Data data = new Data();
                data.setMapData(map);
                data.setChannel("/chat/"+agentName);

                DeliverResponse deliverResponse = new DeliverResponse();
                deliverResponse.setChannel("/chat/"+agentName);
                deliverResponse.setClientId("");
                deliverResponse.setData(data);
                deliverResponse.setLast(true);
                deliverResponse.setFollow(true);
                deliverResponse.setFinished(true);
                context.notify(deliverResponse);
                // out.println("Data is sent.");
                System.out.println("Data is sent.");
            }else{
                //out.println("No data was sent - invalid or missing context.");
                System.out.println("No data was sent - invalid or missing context.");
            }
        }else{
            //out.println("No data was sent - invalid or missing agent name.");
            System.out.println("No data was sent - invalid or missing agent name.");
        }
    }

    protected void service(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        sendMesssage(req, res);
        res.sendRedirect("admin.jsp");
   }
}
