package com.fdms.grizzly.cometd.servlet;

import com.sun.grizzly.cometd.BayeuxParser;
import com.sun.grizzly.cometd.CometdRequest;
import com.sun.grizzly.cometd.CometdResponse;
import com.sun.grizzly.cometd.EventRouter;
import com.sun.grizzly.cometd.EventRouterImpl;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class CometdServlet extends HttpServlet{

    private final BayeuxParser bayeuxParser;
    private final EventRouter eventRouter;
    private final String contextPath = "/Screen//cometd";

    public CometdServlet() {
        bayeuxParser = new BayeuxParser();
        eventRouter = new EventRouterImpl(bayeuxParser);
    }

    @Override
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        config.getServletContext().setAttribute("channellist", new HashMap());
    }

    protected Map getClientParms(String s){
        System.out.println("CometdServlet:getClientParms:s:"+s);
        Map parms = null;
        if(s != null && s.length() > 0){
            int i = s.indexOf("message\":");
            if(i==-1){
                i = s.indexOf("user\":");
            }
            if(i>-1){
                s=s.substring(i);
                i = s.indexOf("{");
                s=s.substring(i+1);
                s=s.replace("\"", "");
                s=s.replace("{", "");
                s=s.replace("}", "");
                StringTokenizer st = new StringTokenizer(s, ":,");
                String key = null;
                String val = null;
                parms = new java.util.HashMap();
                while(st.hasMoreTokens()){
                    key = st.nextToken();
                    val = st.nextToken();
                    parms.put(key, val);
                }
            }
        }
        return parms;
    }

//        protected void broadcast(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
//        System.out.println("SDS:broadcast");
//        // channel map contains current list of available agents
//        Map channelMap = (Map)getServletContext().getAttribute("channellist");
//
//        CometEngine engine = CometEngine.getEngine();
//        CometContext context = engine.getCometContext(contextPath);
//
//        DeliverResponse deliverResponse = new DeliverResponse();
//        String agentName=req.getParameter("agentName");
//
//        Map map = new HashMap();
//        map.put("agentID", req.getParameter("agentID"));
//        map.put("callType", req.getParameter("callType"));
//        map.put("callerID", req.getParameter("callerID"));
//        map.put("mid", req.getParameter("mid"));
//        Data data = new Data();
//        data.setMapData(map);
//        deliverResponse.setChannel("/chat/"+agentName);
//        deliverResponse.setData(data);
//        deliverResponse.setLast(true);
//        deliverResponse.setFollow(true);
//        deliverResponse.setFinished(true);
//        try{
//            context.notify(deliverResponse);
//            System.out.println("message sent to "+agentName);
//        }catch(IllegalMonitorStateException imse){
//            imse.printStackTrace();
//        }catch(Exception e){
//            e.printStackTrace();
//        }
//    }

    @Override
    protected void service(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        System.out.println("CometdServlet:service");

//        String aid = req.getParameter("agentID");
//        if(aid!=null && aid.length()>0){
//            broadcast(req, res);
//            res.sendRedirect("admin.jsp");
//        }else{

            //super.service(req, res);
// ============================================================================
// This code was taken from com.sun.grizzly.cometd.servlet.CometdServlet
// ============================================================================
            CometdRequest cometdReq = (CometdRequest) req.getSession().getAttribute("cometdReq");
            if (cometdReq == null) {
                cometdReq = new CometdRequest<HttpServletRequest>(req) {

                    public String[] getParameterValues(String s) {
                        return request.getParameterValues(s);
                    }

                    @Override
                    public int getRemotePort() {
                        return request.getRemotePort();
                    }

                @Override
                public void setAttribute(String arg0, Object arg1) {
                    throw new UnsupportedOperationException("Not supported yet.");
                }

                @Override
                public Object getAttribute(String arg0) {
                    throw new UnsupportedOperationException("Not supported yet.");
                }
                };

                req.getSession().setAttribute("cometdReq", cometdReq);
            } else {
                cometdReq.setRequest(req);
            }

            CometdResponse cometdRes = (CometdResponse) req.getSession().getAttribute("cometdRes");
            if (cometdRes == null) {
                cometdRes = new CometdResponse<HttpServletResponse>(res) {

                    public void write(String s) throws IOException {
                        response.getWriter().write(s);
                    }

                    public void flush() throws IOException {
                        response.getWriter().flush();
                    }

                    public void setContentType(String s) {
                        response.setContentType(s);
                    }
                };

                req.getSession().setAttribute("cometdRes", cometdRes);
            } else {
                cometdRes.setResponse(res);
            }

            eventRouter.route(cometdReq, cometdRes);
// ============================================================================




            Map parms = getClientParms(req.getParameter("message"));
            if(parms!=null){
                Map channels = (Map)getServletContext().getAttribute("channellist");
                if(parms.containsKey("join")){
                    String val = (String)parms.get("join");
                    if("true".equals(val)){
                        String user = (String)parms.get("usernm");
                        String chan = (String)parms.get("channelnm");
                        channels.put(user, chan);
                        System.out.println(user+" has logged in.");
                    }
                }else if(parms.containsKey("leave")){
                    String val = (String)parms.get("leave");
                    if("true".equals(val)){
                        String user = (String)parms.get("user");
                        channels.remove(user);
                        System.out.println(user+" has logged out.");
                    }
                }
                if(channels!=null){
                    System.out.println("Channel map contains "+channels.size()+" entries");
                }
            }
//        }
    }
}
