dojo.require("dojox.cometd");

var room = {
    _last: "",
    _username: null,


    join: function(name){
        //alert("join:name:"+name);
        if(name != null && name.length>0 ){
            var initString = new String(document.location).replace(/http:\/\/[^\/]*/,'').replace(/\?.*$/,"").replace(/\/\/.*$/,'\/cometd')+"/cometd";
            //alert("pos:join:initString:"+initString);
            dojox.cometd.init(initString);
            this._username=name;

            // latest version of cometd.js will result in 1 round trip to the server instead of 4.
			dojox.cometd.startBatch();
			dojox.cometd.subscribe("/chat/"+name, room, "_chat");
            //alert("pos:join:publish message info:"+name);
            dojox.cometd.publish(   "/chat/"+name,
                                    {"message": {	join:true, usernm:name, channelnm:name,
				  						chat:room._username+" has joined" }}
    		)
            dojox.cometd.endBatch();
        }
    },

	leave: function(){
		//alert("pos:leave:username:"+room._username);
		if (room._username!=null){
			dojox.cometd.startBatch();
			//alert("pos:unsubscribe from /chat/"+room._username+" room:"+room);
			dojox.cometd.unsubscribe("/chat/"+room._username, room, "_chat");
			dojox.cometd.publish("/chat/"+room._username, { user:room._username, leave:true, chat:room._username+" has left"});
			dojox.cometd.endBatch();
			room._username=null;
			dojox.cometd.disconnect();
		}
    },

    chat: function(text){
		//alert("pos:chat:"+text);
		if(!text || !text.length){ return false; }
		dojox.cometd.publish("/chat/"+room._username, { user: room._username, chat: text});
    },

	next: function(text){
		//alert("pos:next:"+text);
		if(!text || !text.length){
			return false;
		}
		dojox.cometd.publish("/chat/"+room._username, {  slide: text});
    },

    _chat: function(message){
		//alert("pos:_chat:"+message);
		var special=message.data.join || message.data.leave;
		var chat=dojo.byId('chat');
        if(!message.data){
            //alert("bad message format "+message);
            return;
        }
        var from=message.data.kuser;
        var special=message.data.join || message.data.leave;
        var text=message.data.chat;

        //alert("Agent ID:"+message.data.agentID+"  Call Type:"+message.data.callType+"  Caller ID:"+message.data.callerID+"  Merchant ID:"+message.data.mid);

        if( !special && from == room._last ){
            from="...";
        }else{
            room._last=from;
            from+=":";
        }

        if(special){
			//alert("pos:_chat:servicing join or leave");
            chat.innerHTML += "<span class=\"alert\"><span class=\"text\">"+text+"</span></span><br/>";
            room._last="";
        }else{
			var loc = "http://localhost:8201/JBossPush/new.jsp?agentID="+message.data.agentID+"&callType="+message.data.callType+"&callerID="+message.data.callerID+"&mid="+message.data.mid;
            //alert("location:"+loc);
			window.top.frames("posFrame").location = loc;
			return true;
        }
        chat.scrollTop = chat.scrollHeight - chat.clientHeight;
    },

	_init: function(){
		//alert("pos:_init");
		dojo.byId('join').className='';
		var i=0;
		var element=dojo.byId('username');
		if(element!=null){
			element.setAttribute("autocomplete","OFF");
			dojo.connect(element, "onkeyup", function(e){
				if(e.keyCode == dojo.keys.ENTER){
					room.join(dojo.byId('username').value);
					return false;
				}
				return true;
			});
		}

		element=dojo.byId('joinB');
		element.onclick = function(){
			//alert("pos:join clicked");
			document.getElementById("joinB").disabled=true;
			document.getElementById("leaveB").disabled=false;
			var un = dojo.byId('username');
			if(un==null){
				un = dojo.byId('username2');
			}
			room.join(un.value);
			return false;
		}

		element=dojo.byId('leaveB');
		element.onclick = function(){
			document.getElementById("leaveB").disabled=true;
			document.getElementById("joinB").disabled=false;
			room.leave();
		}

		//alert("pos:end of init - simulate join click");
		document.getElementById("joinB").click();
    }
};

dojo.addOnLoad(room, "_init");
dojo.addOnUnload(room,"leave");
